# -*- coding: cp1250 -*-
# Knihovny funkci vytvorene pro tento projekt
# Generator samotny a obecne pouzitelna trida pro tvorbu
# L-systemu
from XODEGenerator_L3 import *    
from LSystem_Functions import TLindenmayerSystem

# Vytvorime instanci nejvyssi, 3. vrstvy generatoru
test = XODEGenerator_L3()

# Otevreme novy soubor XODE, hlavicka se automaticky vytvori
test.fileOpenNew('KochovaKrivka.xode')
test.fileWriteLn('<!-- Jednoduchy L-System -->')

# Nastavime barvu pro podlahu a pridame ji do souboru
test.clrSet([255, 128, 64])
test.putFloor()

# Nadefinuje L-System pro tvorbu Kochovy krivky, 
# zadame vychozi stav
l = TLindenmayerSystem("F")

# Pridani promenne a jeji transformace                                              
l.addVariable('F', 'F+F-F-F+F')     

# Pridani konstant                                      
l.addConstant('+')                                                       
l.addConstant('-') 

# Provedeme 3 iterace                                                      
l.iterate(3)

# Nastavime odlisnou barvu pro novou geometrii
test.clrSet([192, 192, 192])

# Vytvorime geometrii
# ( 5 metru dlouhe useky s pauzou pro dvere, otaceni po 90)
test.addLSystemWalls(l.LString, 5, 0.5, 90)                
    
# Zapiseme paticku souboru a zavreme ho
test.fileClose()

print("XODE soubor KochovaKrivka.xode byl uspesne vytvoren")