# -*- coding: cp1250 -*-
#===============================================================================
#=                                  Vrstva 2                                   =
#=               Zajistuje tvorbu slozitych objektu ( nabytku )                =
#=                                                                             =
#=                               Petr Schreiber                                =
#=                                    v1.0                                     =
#===============================================================================
from __future__ import division  # Nutne pro floating point deleni
from XODEGenerator_L1 import *
from math import *

class XODEGenerator_L2(XODEGenerator_L1):

  def __init__(self):
    XODEGenerator_L1.__init__(self)
    
  def addWardrobe(self, width=1, height=2, length=0.5, \
                        angle90=0, \
                        boardWidth=0.05, \
                        backBoard=True, topBoard=True, bottomBoard=True, \
                        shelfNum=5, shelfOffset=0.1, \
                        useDoors=True, leftDoorAngle=45, rightDoorAngle=45 ):
              
    #if (angle90 % 2) <> 0:
    #  temp = width   
    #  width = length
    #  length = temp      
   
    self.posPush()
    #---------------------------------------------------------------------------
    if (angle90 == 0):
      
      if (backBoard == True):
        self.posPush()
        self.posAdd(0, 0, -length/2+boardWidth/2  )
        self.addColumn(width, height, boardWidth)
        self.posPop()
        
      if (topBoard == True):
        self.posPush()
        if (backBoard == True):
          self.posAdd(0, height-boardWidth, boardWidth/2 )
          self.addColumn(width, boardWidth, length-boardWidth)
        else:
          self.posAdd(0, height-boardWidth, 0 )
          self.addColumn(width, boardWidth, length)
        self.posPop() 
        
      if (bottomBoard == True):
        self.posPush()
        if (backBoard == True):
          self.posAdd(0, 0, boardWidth/2 )
          self.addColumn(width, boardWidth, length-boardWidth)
        else:
          self.addColumn(width, boardWidth, length)
        self.posPop() 
        
      # Bocni steny              
      self.posPush()
      self.posSet(-width/2+boardWidth/2, bottomBoard*boardWidth, backBoard*boardWidth/2  ) 
      self.addColumn(boardWidth, height-bottomBoard*boardWidth-topBoard*boardWidth, length-backBoard*boardWidth)
      self.posSet(width/2-boardWidth/2, bottomBoard*boardWidth, backBoard*boardWidth/2  )       
      self.addColumn(boardWidth, height-bottomBoard*boardWidth-topBoard*boardWidth, length-backBoard*boardWidth)
      self.posPop()
      
      # Policky
      self.posPush()
      slfSize = length-(shelfOffset+backBoard*boardWidth)  
      self.posSet(0, 0, -(shelfOffset-backBoard*boardWidth)/2 )
      
      for i in range(0, shelfNum):
        self.posAdd(0, height/(shelfNum+1), 0)
        self.addBox(0, width-2*boardWidth, boardWidth, slfSize)
      self.posPop()
      
      if (useDoors == True):
        # Prave
        self.posPush()
        self.posSet(-width/2+cos(radians(rightDoorAngle))*width/4, 0, length/2+sin(radians(rightDoorAngle))*width/4)
        self.addColumn(width/2, height, boardWidth,rot=[0, rightDoorAngle, 0])
        self.posPop()    
        
        # Leve    
        self.posPush()
        leftDoorAngle = -leftDoorAngle+180 
        self.posSet(width/2+cos(radians(leftDoorAngle))*width/4, 0, length/2+sin(radians(leftDoorAngle))*width/4)
        self.addColumn(width/2, height, boardWidth,rot=[0, leftDoorAngle, 0])        
        self.posPop()         
    #---------------------------------------------------------------------------      
    elif (angle90 == 1):    
      
      if (backBoard == True):
        self.posPush()
        self.posAdd(-length/2+boardWidth/2, 0, 0)
        self.addColumn(boardWidth, height, width)
        self.posPop()
         
      if (topBoard == True):
        self.posPush()
        if (backBoard == True):
          self.posAdd(boardWidth/2, height-boardWidth, 0 )
          self.addColumn(length-boardWidth, boardWidth, width)
        else:
          self.posAdd(0, height-boardWidth, 0 )
          self.addColumn(length, boardWidth, length-boardWidth)
        self.posPop() 
        
      if (bottomBoard == True):
        self.posPush()
        if (backBoard == True):
          self.posAdd(boardWidth/2, 0, 0 )
          self.addColumn(length-boardWidth, boardWidth, width)
        else:
          self.addColumn(length-boardWidth, boardWidth, width)
        self.posPop() 
       
      # Bocni steny              
      self.posPush()
      self.posSet(backBoard*boardWidth/2, bottomBoard*boardWidth, -width/2+boardWidth/2  ) 
      self.addColumn(length-backBoard*boardWidth, height-bottomBoard*boardWidth-topBoard*boardWidth, boardWidth)
      self.posSet(backBoard*boardWidth/2, bottomBoard*boardWidth,  width/2+boardWidth/2  )      
      self.addColumn(length-backBoard*boardWidth, height-bottomBoard*boardWidth-topBoard*boardWidth, boardWidth)
      self.posPop()
      
      # Policky
      self.posPush()
      slfSize = length-(shelfOffset+backBoard*boardWidth)  
      self.posSet(-(shelfOffset-backBoard*boardWidth)/2, 0, 0 )
      
      for i in range(0, shelfNum):
        self.posAdd(0, height/(shelfNum+1), 0)
        self.addBox(0, slfSize, boardWidth, width-2*boardWidth)
      self.posPop()      
      
      # Example of Spaghetti code 
      temp = leftDoorAngle
      leftDoorAngle = 90-rightDoorAngle+180
      rightDoorAngle = 90-temp
      
      if (useDoors == True):
        # Prave
        self.posPush()       
        self.posSet(length/2+cos(radians(rightDoorAngle))*width/4, 0, -width/2+sin(radians(rightDoorAngle))*width/4)
        self.addColumn(width/2, height, boardWidth,rot=[0, rightDoorAngle, 0])
        self.posPop()    
        
        # Leve    
        self.posPush()
        leftDoorAngle = -leftDoorAngle+180
        self.posSet(length/2+cos(radians(leftDoorAngle))*width/4, 0, width/2+sin(radians(leftDoorAngle))*width/4)
        self.addColumn(width/2, height, boardWidth,rot=[0, leftDoorAngle, 0])        
        self.posPop()         
    #---------------------------------------------------------------------------
    elif (angle90 == 2):
     
      
      if (backBoard == True):
        self.posPush()
        self.posAdd(0, 0, length/2-boardWidth/2  )
        self.addColumn(width, height, boardWidth)
        self.posPop()
        
      if (topBoard == True):
        self.posPush()
        if (backBoard == True):
          self.posAdd(0, height-boardWidth, -boardWidth/2 )
          self.addColumn(width, boardWidth, length-boardWidth)
        else:
          self.posAdd(0, height-boardWidth, 0 )
          self.addColumn(width, boardWidth, length)
        self.posPop() 
        
      if (bottomBoard == True):
        self.posPush()
        if (backBoard == True):
          self.posAdd(0, 0, -boardWidth/2 )
          self.addColumn(width, boardWidth, length-boardWidth)
        else:
          self.addColumn(width, boardWidth, length)
        self.posPop() 
        
      # Bocni steny              
      self.posPush()
      self.posSet(-width/2+boardWidth/2, bottomBoard*boardWidth, backBoard*boardWidth/2  ) 
      self.addColumn(boardWidth, height-bottomBoard*boardWidth-topBoard*boardWidth, length-backBoard*boardWidth)
      self.posSet(width/2-boardWidth/2, bottomBoard*boardWidth, backBoard*boardWidth/2  )       
      self.addColumn(boardWidth, height-bottomBoard*boardWidth-topBoard*boardWidth, length-backBoard*boardWidth)
      self.posPop()
      
      # Policky
      self.posPush()
      slfSize = length-(shelfOffset+backBoard*boardWidth)  
      self.posSet(0, 0, (shelfOffset-backBoard*boardWidth)/2 )
      
      for i in range(0, shelfNum):
        self.posAdd(0, height/(shelfNum+1), 0)
        self.addBox(0, width-2*boardWidth, boardWidth, slfSize)
      self.posPop()
      
      if (useDoors == True):
        # Prave
        self.posPush()
        rightDoorAngle = rightDoorAngle + 180
        self.posSet(width/2+cos(radians(rightDoorAngle))*width/4, 0, -length/2+sin(radians(rightDoorAngle))*width/4)
        self.addColumn(width/2, height, boardWidth,rot=[0, rightDoorAngle, 0])
        self.posPop()    
        
        # Leve    
        self.posPush()
        leftDoorAngle = -leftDoorAngle+180 +180
        self.posSet(-width/2+cos(radians(leftDoorAngle))*width/4, 0, -length/2+sin(radians(leftDoorAngle))*width/4)
        self.addColumn(width/2, height, boardWidth,rot=[0, leftDoorAngle, 0])        
        self.posPop()   
    #---------------------------------------------------------------------------        
    elif (angle90 == 3):
            
      if (backBoard == True):
        self.posPush()
        self.posAdd(length/2-boardWidth/2, 0, 0)
        self.addColumn(boardWidth, height, width)
        self.posPop()
         
      if (topBoard == True):
        self.posPush()
        if (backBoard == True):
          self.posAdd(boardWidth/2, height-boardWidth, 0 )
          self.addColumn(length-boardWidth, boardWidth, width)
        else:
          self.posAdd(0, height-boardWidth, 0 )
          self.addColumn(length, boardWidth, length-boardWidth)
        self.posPop() 
        
      if (bottomBoard == True):
        self.posPush()
        if (backBoard == True):
          self.posAdd(boardWidth/2, 0, 0 )
          self.addColumn(length-boardWidth, boardWidth, width)
        else:
          self.addColumn(length-boardWidth, boardWidth, width)
        self.posPop() 
       
      # Bocni steny              
      self.posPush()
      self.posSet(backBoard*boardWidth/2, bottomBoard*boardWidth, -width/2+boardWidth/2  ) 
      self.addColumn(length-backBoard*boardWidth, height-bottomBoard*boardWidth-topBoard*boardWidth, boardWidth)
      self.posSet(backBoard*boardWidth/2, bottomBoard*boardWidth,  width/2+boardWidth/2  )      
      self.addColumn(length-backBoard*boardWidth, height-bottomBoard*boardWidth-topBoard*boardWidth, boardWidth)
      self.posPop()
      
      # Policky
      self.posPush()
      slfSize = length-(shelfOffset+backBoard*boardWidth)  
      self.posSet((shelfOffset-backBoard*boardWidth)/2, 0, 0 )
      
      for i in range(0, shelfNum):
        self.posAdd(0, height/(shelfNum+1), 0)
        self.addBox(0, slfSize, boardWidth, width-2*boardWidth)
      self.posPop()      
      
      # Example of Spaghetti code 
      temp = leftDoorAngle

      leftDoorAngle  = 90-leftDoorAngle
      rightDoorAngle = 90-rightDoorAngle
      if (useDoors == True):
        # Prave
        self.posPush()       
        self.posSet(-length/2-cos(radians(rightDoorAngle))*width/4, 0, width/2-sin(radians(rightDoorAngle))*width/4)
        self.addColumn(width/2, height, boardWidth,rot=[0, rightDoorAngle, 0])
        self.posPop()    
        
        # Leve    
        self.posPush()
        leftDoorAngle = -leftDoorAngle
        self.posSet(-length/2-cos(radians(leftDoorAngle))*width/4, 0, -width/2-sin(radians(leftDoorAngle))*width/4)
        self.addColumn(width/2, height, boardWidth,rot=[0, leftDoorAngle, 0])        
        self.posPop()         
      
       
    #---------------------------------------------------------------------------        
    self.posPop()   
        
    
  def addTable(self, width=1, height=1, length=2, \
                     angle90=0, \
                     boardHeight=0.05, boardShape='box', \
                     legEdge=0.05, legDist1=0.9, legDist2=1.8 ):   
                                       
     
    if (angle90 % 2) <> 0:
      temp = legDist1   
      legDist1 = legDist2
      legDist2 = temp

      temp = width   
      width = length
      length = temp 
                         
    self.posPush()
    self.posPush()
    
    if (boardShape == 'box'):
      self.posPush()
      self.posAdd(0, height-boardHeight/2, 0)
      self.addBox(0, width, boardHeight, length)
      self.posPop()
    elif (boardShape == 'cylinder'):      
      self.posAdd(0, height-boardHeight/2, 0)
      self.addCylinder(0, width/2, boardHeight, 2)

    self.posPop()
    
    self.posPush()
    self.posAdd(legDist1/2, 0, legDist2/2)
    self.addColumn(legEdge, height-boardHeight, legEdge)
    self.posPop()
    
    # Nohy stolu ( 4, 2, 1; zalezi na parametrech legDistN )
    if (legDist1 != 0):
      self.posPush()
      self.posAdd(-legDist1/2, 0, legDist2/2)
      self.addColumn(legEdge, height-boardHeight, legEdge)
      self.posPop()

    if (legDist1+legDist2 != 0):
      self.posPush()
      self.posAdd(legDist1/2, 0,-legDist2/2)
      self.addColumn(legEdge, height-boardHeight, legEdge)
      self.posPop()
  
      if (legDist2 != 0):
        self.posPush()
        self.posAdd(-legDist1/2, 0,-legDist2/2)
        self.addColumn(legEdge, height-boardHeight, legEdge)
        self.posPop()
            
    self.posPop()                                  
       
  def addChair(self, width=0.5, height=1, length=0.5, \
                     angle90=0, \
                     boardHeight=0.05, boardY=0.5, \
                     legEdge=0.01, legDist1=0.4, legDist2=0.4 ):    
                  
    self.addTable(width, boardY, length, angle90, boardHeight, 'box', legEdge, legDist1, legDist2)
    if (angle90 % 2) <> 0:
      temp = legDist1   
      legDist1 = legDist2
      legDist2 = temp

      temp = width   
      width = length
      length = temp     
    
    self.posPush()
    if (angle90 == 0):
      self.posAdd(0, boardY, -length/2+boardHeight/2)
      self.addColumn(width, height-boardY, boardHeight)
      
    elif (angle90 == 1):
      self.posAdd(-width/2+boardHeight/2, boardY, 0)
      self.addColumn(boardHeight, height-boardY, length)

    elif (angle90 == 2):
      self.posAdd(0, boardY, length/2-boardHeight/2)
      self.addColumn(width, height-boardY, boardHeight)
    
    elif (angle90 == 3):
      self.posAdd(width/2-boardHeight/2, boardY, 0)
      self.addColumn(boardHeight, height-boardY, length)

    self.posPop()                     
      