# -*- coding: cp1250 -*-
#===============================================================================
#=                                  Vrstva 0                                   =
#=                    Zajistuje zakladni praci se souborem                     =
#=                                                                             =
#=                            Petr Schreiber, 2008                             =
#=                                    v1.0                                     =
#===============================================================================
from __future__ import division  # Nutne pro floating point deleni
from os import * 
from string import *

class XODEGenerator_L0:
  
  # Konstruktor, inicalizuje pripadne properties
  def __init__(self):
    self.fHandle = 0    
    
  # Destruktor, zajistuje korektni zavreni souboru  
  def __del__(self):  
    if (self.fHandle != 0):
      self.fileClose()
      print ("[i] Varovani : Zapomneli jste zavrit soubor "+self.fName)

  # Zapise informaci do souboru
  def fileWrite(self, what):
    try:
      self.fHandle.write(what)
    except:
      print ("[!] Chyba : Neni mozno zapisovat do souboru")  
      
  # Zapise informaci do souboru
  def fileWriteLn(self, what):
    try:
      what += '\n'
      self.fHandle.write(what)
    except:
      print ("[!] Chyba : Neni mozno zapisovat do souboru")        

  # Zapise informaci do souboru
  def fileWriteMultiLine(self, what):
    try:
      what += '\n'
      self.fHandle.writelines(what)
    except:
      print ("[!] Chyba : Neni mozno zapisovat do souboru")  
         
  # Otevre soubor jako novy, pokud existuje, bude prepsan  
  def fileOpenNew(self, fName ):
    self.fName   = fName
    self.fHandle = file(fName, "w")
    self.fAccess = "XODE_NEW"
    self.fileWrite("<xode>\n<world name=\"world\">\n<space name=\"space\">\n")
  
  # Otevre existujici XODE soubor, a zapisuje pred tag <space/>  
  def fileOpenExisting(self, fName ):
    self.fName   = fName
    self.fHandle = file(fName, "r")
    fLines = self.fHandle.readlines()
    self.fHandle.close()
    
    self.fAccess = "XODE_APPEND"    
    self.fHandle = file(fName, "w")
    
    try:
      fLines.remove('</space>\n')
      fLines.remove('</world>\n')
      fLines.remove('</xode>')

      tempS = join(fLines, '')
      self.fileWrite(tempS)
      self.fHandle.close()
      
      self.fHandle = file(fName, "a")
      
    except:
      print ("[!] Chyba : Soubor "+self.fName+" nebyl vytvoren generatorem, a proto do nej neni mozno bezpecne pripisovat data")      
      self.fHandle.close()
      self.fHandle = 0     
        
  # Bezpecne zavre soubory       
  def fileClose(self):
    if (self.fHandle != 0):
      
      self.fileWrite("\n</space>\n</world>\n</xode>")
               
      self.fHandle.close()
      self.fHandle = 0
            