#===============================================================================
#=                            Soucast vzoroskriptu                             =
#=                                     v5                                      =
#===============================================================================
## 2008.03.26
# - pridany reprezentace objektu trimesh, plane
# - DL se tvori i nici samy ( novy destruktor )
# - uprava vykreslovaci fce

from __future__ import division # u volani gluPerspective (45, width/height, 1, 512)
                                # width/height bohuzel vzdy vychazi jako integer,
                                # pro 640x480 to znamena 1 misto 1.33, proto jsou telesa "smackla"
                                # zatim asi jedina moznost upravy tohoto chovani je dat na zacatek skriptu (-Schr.)
                                
from OpenGL.GL import *     ## PyOpenGL
from OpenGL.GLU import *    ## PyOpenGL
from OpenGL.GLUT import *   ## PyOpenGL
import sys
import math


class PaintSim:
  """ trida zajistuje vse co souvisi s vykreslovanim """

  # PRIVATE
  def __Geoms2Lists(self, aListOfGeoms):
    global displayListIndex, quad
    global quad                                           # by se to melo delat jinde a hlavne jen jednou ?!
    quad = gluNewQuadric()  #kvuli vykreslovani valce     # by se to melo delat jinde a hlavne jen jednou ?!
    glGenLists(len(aListOfGeoms))
    index = 0
    for g in aListOfGeoms:
        index += 1
        g.displayList = index
        
        glNewList(index, GL_COMPILE)
        
        glColor3ubv(g.color)                # preda barvu jako pointer, rychlejsi!
        
        if g.shape == "sphere":                        
            glutSolidSphere(g.radius,15,15) #rdius,slices,stacks
                                            #vlastnost g.radius jsem tam pridal u vytvoreni shape pro kouli
        elif g.shape =="box":
            sx,sy,sz = g.boxsize            #odbdobne boxsize
            glScalef(sx, sy, sz)            #multiply the current matrix by a general scaling matrix,
                                            #produces a nonuniform scaling along the x,	y, and z axes
            glutSolidCube(1)                #param: length of each edge
        elif g.shape =="cylinder":              
            glTranslatef(0.0, 0.0, -g.length/2) #musim posunout o polovinu pozici vykreslovani ve smeru
                                                   # osy valce, jelikoz ODE bere pozici teziste, kdezto OpenGL
                                                   # bere pozici stred spodni podstavy
            gluCylinder( quad , g.radius, g.radius, g.length, 128, 128 )
                                                   #obdobne radius a length
                                                   # quad , radius at z=0, radius at z=top, height, number of subdivisons around z, along z
            gluDisk(quad, 0, g.radius, 128, 128)# vykresli disk quad, vnitrni radius, vnejsi radius, pocet slupek
                    
            glTranslatef(0.0, 0.0, g.length)       # u Mass jsem nastavil direction na 3 to jest v ose z, proto musim posunout
                                                                       # vykreslovani o delku valce a to v ose z
            gluDisk(quad, 0, g.radius, 128, 128)
         
        elif g.shape == "cappedCylinder":
            glTranslatef(0.0, 0.0, -g.length/2) #musim posunout o polovinu pozici vykreslovani ve smeru
                                                #osy valce, jelikoz ODE bere pozici teziste, kdezto OpenGL bere pozici stred spodni podstavy
            gluCylinder( quad , g.radius, g.radius, g.length, 128, 128 )
                                                 #obdobne radius a length
                                                 # quad , radius at z=0, radius at z=top,height, number of subdivisons around z, along z
            glutSolidSphere(g.radius, 128, 128)  # vykresli kouli o danem radiusu, pocet slupek, pocet slupek
            glTranslatef(0.0, 0.0, g.length)     #??? Mass jsem nastavil direction na 3 to jest v ose z, proto musim posunout
                                                 # vykreslovani o delku valce a to v ose z
            glutSolidSphere(g.radius, 128, 128)  # vykresli kouli o danem radiusu, pocet slupek, pocet slupek
        elif g.shape == "plane":
            dx = math.degrees(math.atan2(g.c, g.b))
            dz = -math.degrees(math.atan2(g.a, g.b))
            
            glTranslatef(0,g.d,0)
            glRotatef (dz,0,0,1)
            glRotatef (dx,1,0,0)    
                              
            glBegin(GL_QUADS)        
            glNormal3f(0, 1, 0)                
            glVertex3f(-100, 0,  100)
            glVertex3f( 100, 0,  100)
            glVertex3f( 100, 0, -100)
            glVertex3f(-100, 0, -100)         
            glEnd()         
            glPointSize(2)
            glBegin(GL_POINTS)
            glColor3ub(0,0,0)
            for i in range(-100, 100):
              for j in range(-100, 100):
                glVertex3f(i, 0, j)
            glEnd()
            glPointSize(1)
        elif g.shape == "trimesh":
          # nasledujici kod ja za normalnich podminek temer smrtonosne neefektivni
          # rychlost vsak zachranuje kopilace do display listu
          # lepsi alternativy pro realtime mesh by byly vertex arrays a vertex buffer objects
          glBegin(GL_TRIANGLES)
          x, y, z = g.getPosition()
          ux, uy, uz = 0, 0, 0
          vx, vy, vz = 0, 0, 0    
          
          for t in range(0, g.NumTriangles):
            # Vypocet normaloveho vektoru
            ux = g.getTriangle(t)[1][0] - g.getTriangle(t)[0][0]  
            uy = g.getTriangle(t)[1][1] - g.getTriangle(t)[0][1]
            uz = g.getTriangle(t)[1][2] - g.getTriangle(t)[0][2]
            
            vx = g.getTriangle(t)[2][0] - g.getTriangle(t)[0][0]  
            vy = g.getTriangle(t)[2][1] - g.getTriangle(t)[0][1]
            vz = g.getTriangle(t)[2][2] - g.getTriangle(t)[0][2]
            
            nx = (uy * vz - uz * vy)
            ny = -(ux * vz - uz * vx)
            nz = (ux * vy - uy * vx)
            
            nl = math.sqrt(nx*nx + ny*ny + nz*nz)
      
            nx = nx / nl
            ny = ny / nl
            nz = nz / nl
            
            # Normalovy vektor staci zadat pro prvni vertex v trojuhelniku
            glNormal3f(nx, ny, nz)           
            
            if g.getBody() != None:
              for v in range(0,3):
                glVertex3f(g.getTriangle(t)[v][0]-x, g.getTriangle(t)[v][1]-y, g.getTriangle(t)[v][2]-z)
            else:
              for v in range(0,3):
                glVertex3f(g.getTriangle(t)[v][0], g.getTriangle(t)[v][1], g.getTriangle(t)[v][2])

          glEnd()
                
        else:
            print("[!]nevim co mam kreslit"+g.shape)

        glEndList()
  
  def __IdleFunc(self):
    if self.calcFunc() == -1:
      self.finalFunc()            # Jeste nez ujoncim proces, mam sanci neco udelat
      sys.exit(0)
      
    else:  
      glutPostRedisplay()
     
  def __DisplayFunc(self):
      """ nakresli prostredi, telesa, vazby, monu lisu apod. """
      #funkce je pouzita jako parametr glutDisplayFunc
      #--> ta se vyvola diky glutPostRedisplay ve funkci _idlefunc
      
      global listOfBodies
      global listOfJoints
  
      glClear( GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT )  # Smaze buffery ( obraz + hloubka )
                                                            # Okno se vyplni barvou udanou drive pomoci glClearColor a 
                                                            # depth buffer se vyplni nejvzdalenejsi hloubkou    
    
      glLoadIdentity()                                      # Resetuje transformace ( nacte matici identity )
      gluLookAt (-10, 2, -5,     # x,y,z kde je "kamera" 
                 -11.5, 0.0, -8.0,     # x,y,z kam kouka "kamera"
                 0.0, 1.0, 0.0)     # upvector 
  
      for g in self.ListOfGeoms:
          
          # plane je pevny, a transformace ma jiz zapecene v display listu
          # v pripade ze je trimesh pevny, transformace ma jiz zapecene v display listu             
          if (g.shape == "plane") or (g.shape == "trimesh" and g.getBody() == None):
            if g.getBody() == None:
              transform = [1.0, 0.0, 0.0, 0.0,
                           0.0, 1.0, 0.0, 0.0,
                           0.0, 0.0, 1.0, 0.0,
                           0.0, 0.0, 0.0, 1.0]    
          # jinak provedeme standardni transformaci - zapis lokalnich os XYZ do globalnich souradnic + pozice        
          else:
            x,y,z = g.getPosition()
            R = g.getRotation()
            transform = [R[0], R[3], R[6], 0.0,
                         R[1], R[4], R[7], 0.0,
                         R[2], R[5], R[8], 0.0,
                            x,    y,    z, 1.0]   
                              
  
          # glPushMatrix / glPopMatrix slouzi k izolaci "objektu"
          # Proto se nam pri postupnem vykreslovani bodies transformace neretezi ale jdou relativne k neutralnimu stavu       
          glPushMatrix() 
  
          # Nasobi aktualni matici transformaci
          # Jen diky tomu ze jsme v glPushMatrix / glPopMatrix, nedojde k ovlivneni polohy objektu v dalsim kroku cyklu
          glMultMatrixd(transform)
          
          # Zavola display list
          glCallList(g.displayList)
               
          glPopMatrix() 
          
      # Vsechny prikazy az sem se zapisovali do "back bufferu". "front buffer" zustal netknuty,
      # proto neni videt jak se objekty postupne kresli. 
      # glutSwapBuffers() zobrazi obsah back bufferu jak nejrychleji to pujde ( limitovano pouze fillrate karty )          
      glutSwapBuffers()
          
  def __ReshapeFunc(self, x, y):
    """ Zajisti udrzovani spravnych proporci grafiky """
    # Viewport se roztahne pres celou klientskou oblast
    glViewport (0, 0, x, y)
    
    # Nastavi se znova FOV, pomer stran a orezavaci roviny
    glMatrixMode (GL_PROJECTION)
    glLoadIdentity()
    gluPerspective (45, x/y, 0.1, 512)
    
    # 
    glMatrixMode (GL_MODELVIEW)    
    glLoadIdentity()     

  def __CreateWindow(self,aWidth,aHeight,aWindowTitle):
    """ zajisti vytvoreni okna a nastaveni vychozich parametru pro kresleni pomoci OpenGL  """
    
    if self.hWnd <> 0:
      print "[!] Window already exists, you cannot run multiple windows at the same time!"
      
    #to stejne jako _CreateWindow z puvodniho navrhu
    #jako dalsi parametry by mela vstupovat vychozi barva pozdai a vyzchozi barva teles !!!
    
    #instancni promene   
    width = aWidth
    height = aHeight
    windowTitle = aWindowTitle
    #--
     
    glutInit ([])                                     # Inicializace GLUT
    glutInitDisplayMode ( GLUT_DOUBLE | GLUT_RGBA )   # Double buffer redukuje blikani pri vykreslovani, RGBA mod je nejrychlejsi  

    glutInitWindowPosition (-1, -1)                   # system si umisti okno sam
    glutInitWindowSize (width, height)                # nastaveni velikosti okna
    lhWnd = glutCreateWindow (windowTitle)                    # vytvoreni okna

    # -- Nasleduje nastaveni OpenGL
    # -- OpenGL pracuje jako "state machine" - tzn. pokud neco zapnu tak to zustane zapnute dokud to nevypnu :)

    # -- Nastaveni svetla
    glLightfv(GL_LIGHT0,GL_POSITION,[15,15,15,0])     # Umisti svetlo na pozici 15, 15, 15
    glLightfv(GL_LIGHT0,GL_DIFFUSE ,[1,1,1,1])        # Svetlo se jevi jako bile ( RGB se slozkami v intervalu [0,1] )
    glLightfv(GL_LIGHT0,GL_SPECULAR,[1,1,1,1])        # Bile odrazy
    glEnable (GL_LIGHT0)                              # Zapne jeden svetelny zdroj
    glEnable(GL_LIGHTING)                             # Zapne nasvetleni jako takove

    glEnable(GL_COLOR_MATERIAL)                       # Umoznuje pusobeni svetla pri zachovani barvy telesa
    glShadeModel(GL_SMOOTH)                           # Relativne plynuly prechod svetla ( per vertex )
    glEnable(GL_NORMALIZE)                            # Automaticky normalizuje normaly (-Schr.)
    glEnable (GL_AUTO_NORMAL)                         # Automaticky normalizuje normaly i po zmene rozmeru pomoci glScale<pismeno> (-Schr.) 
    
    glEnable(GL_DEPTH_TEST)                           # Zajisti spravne vykreslovani ( poradi ) fragmentu primitiv  
    glDepthMask(GL_TRUE)                              
    glDepthFunc(GL_LESS)                              # Zapisuje pouze fragmenty s mensi hloubkou nez je stavajici                            


    glViewport(0,0,width,height)                      # Nastavi "okno v okne" do ktereho se bude kreslit,
                                                      # musi byt mensi nebo stejne velke jako klientska oblast okna
    
    # -- nastaveni transformacnich matic           			
    glMatrixMode(GL_PROJECTION) # Nastaveni projekce
    glLoadIdentity()            # Nacte do GL_PROJECTION matici [ 1, 0, 0 ]
                                #                               [ 0, 1, 0 ]   
                                #                               [ 0, 0, 1 ]
    # -- Perspektiva, 45 deg FOV ( Field-Of-View ), spravny pomer stran a predni a zadni orezovou rovinu                                                                                            
    gluPerspective (45, width/height, 0.1, 512)

    glMatrixMode(GL_MODELVIEW)  # Matice modelview se stara o posouvani objektu ve scene
    glLoadIdentity()            # Nacte do GL_MODELVIEW matici  [ 1, 0, 0 ]
                                #                               [ 0, 1, 0 ]   
                                #                               [ 0, 0, 1 ]

    glClearColor(0.0,0.25,0.5,1.0) # vychozi barva pozadi
    glColor3ubv ([255, 255, 255])  # vychozi barva teles, zustane dokud ji nekdo nezmeni
    
    # Nastaveni GLUT callbacku
    glutReshapeFunc(self.__ReshapeFunc)
    glutDisplayFunc(self.__DisplayFunc)
    
    return lhWnd
 
  def __DestroyWindow(self):
    if self.hWnd <> 0:
      glutDestroyWindow(self.hWnd)
      self.hWnd = 0
    else:
      print "[!] No window to destroy"

  
  # PUBLIC
  # ~ 
  def __init__(self,aWidth=640,aHeight=480,aWindowTitle=""):
    """ pripravi okno, nastavi prametry kresleni, vytvori display listy """
    self.hWnd = 0          
    self.winWidth  = aWidth
    self.winHeight = aHeight
    self.winTitle  = aWindowTitle
    self.numLists  = 0
    return
    
  def __del__(self):
    if self.numLists > 0:
      glDeleteLists (0, self.numLists)
      # ?  
      self.DestroyWindow()  

  def Visualize(self, aListOfGeoms, aCalcFunc, aFinalFunc ):
    self.hWnd = self.__CreateWindow(self.winWidth,self.winHeight,self.winTitle)
    self.ListOfGeoms = aListOfGeoms        
    self.__Geoms2Lists(aListOfGeoms)
    self.numLists = len(aListOfGeoms)
    
    print "Handle GLUT okna: ",  self.hWnd
    
    self.calcFunc  = aCalcFunc   # tuto fci bude volat IDLE
    self.finalFunc = aFinalFunc  # tato funkce se zavola az simulace skonci, s GLUTem to asi jinak nepujde
    
    glutIdleFunc(self.__IdleFunc)
    
    glutMainLoop()     

    
